]> git.street.me.uk Git - andy/dehydrated.git/blame_incremental - test.sh
examples/hook: no bashism (#300)
[andy/dehydrated.git] / test.sh
... / ...
CommitLineData
1#!/usr/bin/env bash
2
3# Fail early
4set -eu -o pipefail
5
6# Check if running in CI environment
7if [[ ! "${CI:-false}" == "true" ]]; then
8 echo "ERROR: Not running in CI environment!"
9 exit 1
10fi
11
12_TEST() {
13 echo
14 echo "${1} "
15}
16_SUBTEST() {
17 echo -n " + ${1} "
18}
19_PASS() {
20 echo -e "[\u001B[32mPASS\u001B[0m]"
21}
22_FAIL() {
23 echo -e "[\u001B[31mFAIL\u001B[0m]"
24 echo
25 echo "Problem: ${@}"
26 echo
27 echo "STDOUT:"
28 cat tmplog
29 echo
30 echo "STDERR:"
31 cat errorlog
32 exit 1
33}
34_CHECK_FILE() {
35 _SUBTEST "Checking if file '${1}' exists..."
36 if [[ -e "${1}" ]]; then
37 _PASS
38 else
39 _FAIL "Missing file: ${1}"
40 fi
41}
42_CHECK_LOG() {
43 _SUBTEST "Checking if log contains '${1}'..."
44 if grep -- "${1}" tmplog > /dev/null; then
45 _PASS
46 else
47 _FAIL "Missing in log: ${1}"
48 fi
49}
50_CHECK_NOT_LOG() {
51 _SUBTEST "Checking if log doesn't contain '${1}'..."
52 if grep -- "${1}" tmplog > /dev/null; then
53 _FAIL "Found in log: ${1}"
54 else
55 _PASS
56 fi
57}
58_CHECK_ERRORLOG() {
59 _SUBTEST "Checking if errorlog is empty..."
60 if [[ -z "$(cat errorlog)" ]]; then
61 _PASS
62 else
63 _FAIL "Non-empty errorlog"
64 fi
65}
66
67# If not found (should be cached in travis) download ngrok
68if [[ ! -e "ngrok/ngrok" ]]; then
69 (
70 mkdir -p ngrok
71 cd ngrok
72 wget https://dl.ngrok.com/ngrok_2.0.19_linux_amd64.zip -O ngrok.zip
73 unzip ngrok.zip ngrok
74 chmod +x ngrok
75 )
76fi
77
78# Run ngrok and grab temporary url from logfile
79ngrok/ngrok http 8080 --log stdout --log-format logfmt --log-level debug > tmp.log &
80ngrok/ngrok http 8080 --log stdout --log-format logfmt --log-level debug > tmp2.log &
81ngrok/ngrok http 8080 --log stdout --log-format logfmt --log-level debug > tmp3.log &
82sleep 2
83TMP_URL="$(grep -Eo "Hostname:[a-z0-9]+.ngrok.io" tmp.log | head -1 | cut -d':' -f2)"
84TMP2_URL="$(grep -Eo "Hostname:[a-z0-9]+.ngrok.io" tmp2.log | head -1 | cut -d':' -f2)"
85TMP3_URL="$(grep -Eo "Hostname:[a-z0-9]+.ngrok.io" tmp3.log | head -1 | cut -d':' -f2)"
86if [[ -z "${TMP_URL}" ]] || [[ -z "${TMP2_URL}" ]] || [[ -z "${TMP3_URL}" ]]; then
87 echo "Couldn't get an url from ngrok, not a dehydrated bug, tests can't continue."
88 exit 1
89fi
90
91# Run python webserver in .acme-challenges directory to serve challenge responses
92mkdir -p .acme-challenges/.well-known/acme-challenge
93(
94 cd .acme-challenges
95 python -m SimpleHTTPServer 8080 > /dev/null 2> /dev/null
96) &
97
98# Generate config and create empty domains.txt
99echo 'CA="https://testca.kurz.pw/directory"' > config
100echo 'LICENSE="https://testca.kurz.pw/terms/v1"' >> config
101echo 'WELLKNOWN=".acme-challenges/.well-known/acme-challenge"' >> config
102echo 'RENEW_DAYS="14"' >> config
103touch domains.txt
104
105# Check if help command is working
106_TEST "Checking if help command is working..."
107./dehydrated --help > tmplog 2> errorlog || _FAIL "Script execution failed"
108_CHECK_LOG "Default command: help"
109_CHECK_LOG "--help (-h)"
110_CHECK_LOG "--domain (-d) domain.tld"
111_CHECK_ERRORLOG
112
113# Run in cron mode with empty domains.txt (should only generate private key and exit)
114_TEST "First run in cron mode, checking if private key is generated and registered"
115./dehydrated --cron > tmplog 2> errorlog || _FAIL "Script execution failed"
116_CHECK_LOG "Registering account key"
117_CHECK_FILE accounts/*/account_key.pem
118_CHECK_ERRORLOG
119
120# Temporarily move config out of the way and try signing certificate by using temporary config location
121_TEST "Try signing using temporary config location and with domain as command line parameter"
122mv config tmp_config
123./dehydrated --cron --domain "${TMP_URL}" --domain "${TMP2_URL}" -f tmp_config > tmplog 2> errorlog || _FAIL "Script execution failed"
124_CHECK_NOT_LOG "Checking domain name(s) of existing cert"
125_CHECK_LOG "Generating private key"
126_CHECK_LOG "Requesting challenge for ${TMP_URL}"
127_CHECK_LOG "Requesting challenge for ${TMP2_URL}"
128_CHECK_LOG "Challenge is valid!"
129_CHECK_LOG "Creating fullchain.pem"
130_CHECK_LOG "Done!"
131_CHECK_ERRORLOG
132mv tmp_config config
133
134# Add third domain to command-lime, should force renewal.
135_TEST "Run in cron mode again, this time adding third domain, should force renewal."
136./dehydrated --cron --domain "${TMP_URL}" --domain "${TMP2_URL}" --domain "${TMP3_URL}" > tmplog 2> errorlog || _FAIL "Script execution failed"
137_CHECK_LOG "Domain name(s) are not matching!"
138_CHECK_LOG "Forcing renew."
139_CHECK_LOG "Generating private key"
140_CHECK_LOG "Requesting challenge for ${TMP_URL}"
141_CHECK_LOG "Requesting challenge for ${TMP2_URL}"
142_CHECK_LOG "Requesting challenge for ${TMP3_URL}"
143_CHECK_LOG "Challenge is valid!"
144_CHECK_LOG "Creating fullchain.pem"
145_CHECK_LOG "Done!"
146_CHECK_ERRORLOG
147
148# Prepare domains.txt
149# Modify TMP3_URL to be uppercase to check for upper-lower-case mismatch bugs
150echo "${TMP_URL} ${TMP2_URL} $(tr 'a-z' 'A-Z' <<<"${TMP3_URL}")" >> domains.txt
151
152# Run in cron mode again (should find a non-expiring certificate and do nothing)
153_TEST "Run in cron mode again, this time with domain in domains.txt, should find non-expiring certificate"
154./dehydrated --cron > tmplog 2> errorlog || _FAIL "Script execution failed"
155_CHECK_LOG "Checking domain name(s) of existing cert... unchanged."
156_CHECK_LOG "Skipping renew"
157_CHECK_ERRORLOG
158
159# Disable private key renew
160echo 'PRIVATE_KEY_RENEW="no"' >> config
161
162# Run in cron mode one last time, with domain in domains.txt and force-resign (should find certificate, resign anyway, and not generate private key)
163_TEST "Run in cron mode one last time, with domain in domains.txt and force-resign"
164./dehydrated --cron --force > tmplog 2> errorlog || _FAIL "Script execution failed"
165_CHECK_LOG "Checking domain name(s) of existing cert... unchanged."
166_CHECK_LOG "Ignoring because renew was forced!"
167_CHECK_NOT_LOG "Generating private key"
168_CHECK_LOG "Requesting challenge for ${TMP_URL}"
169_CHECK_LOG "Requesting challenge for ${TMP2_URL}"
170_CHECK_LOG "Requesting challenge for ${TMP3_URL}"
171_CHECK_LOG "Challenge is valid!"
172_CHECK_LOG "Creating fullchain.pem"
173_CHECK_LOG "Done!"
174_CHECK_ERRORLOG
175
176# Check if signcsr command is working
177_TEST "Running signcsr command"
178./dehydrated --signcsr certs/${TMP_URL}/cert.csr > tmplog 2> errorlog || _FAIL "Script execution failed"
179_CHECK_LOG "BEGIN CERTIFICATE"
180_CHECK_LOG "END CERTIFICATE"
181_CHECK_NOT_LOG "ERROR"
182
183# Check if renewal works
184_TEST "Run in cron mode again, to check if renewal works"
185echo 'RENEW_DAYS="300"' >> config
186./dehydrated --cron > tmplog 2> errorlog || _FAIL "Script execution failed"
187_CHECK_LOG "Checking domain name(s) of existing cert... unchanged."
188_CHECK_LOG "Renewing!"
189_CHECK_ERRORLOG
190
191# Check if certificate is valid in various ways
192_TEST "Verifying certificate..."
193_SUBTEST "Verifying certificate on its own..."
194openssl x509 -in "certs/${TMP_URL}/cert.pem" -noout -text > tmplog 2> errorlog && _PASS || _FAIL
195_CHECK_LOG "CN=${TMP_URL}"
196_CHECK_LOG "${TMP2_URL}"
197_SUBTEST "Verifying file with full chain..."
198openssl x509 -in "certs/${TMP_URL}/fullchain.pem" -noout -text > /dev/null 2>> errorlog && _PASS || _FAIL
199_SUBTEST "Verifying certificate against CA certificate..."
200(openssl verify -verbose -CAfile "certs/${TMP_URL}/fullchain.pem" -purpose sslserver "certs/${TMP_URL}/fullchain.pem" 2>&1 || true) | (grep -v ': OK$' || true) >> errorlog 2>> errorlog && _PASS || _FAIL
201_CHECK_ERRORLOG
202
203# Revoke certificate using certificate key
204_TEST "Revoking certificate..."
205./dehydrated --revoke "certs/${TMP_URL}/cert.pem" --privkey "certs/${TMP_URL}/privkey.pem" > tmplog 2> errorlog || _FAIL "Script execution failed"
206REAL_CERT="$(readlink -n "certs/${TMP_URL}/cert.pem")"
207_CHECK_LOG "Revoking certs/${TMP_URL}/${REAL_CERT}"
208_CHECK_LOG "Done."
209_CHECK_FILE "certs/${TMP_URL}/${REAL_CERT}-revoked"
210_CHECK_ERRORLOG
211
212# Test cleanup command
213_TEST "Cleaning up certificates"
214./dehydrated --cleanup > tmplog 2> errorlog || _FAIL "Script execution failed"
215_CHECK_LOG "Moving unused file to archive directory: ${TMP_URL}/cert-"
216_CHECK_LOG "Moving unused file to archive directory: ${TMP_URL}/chain-"
217_CHECK_LOG "Moving unused file to archive directory: ${TMP_URL}/fullchain-"
218_CHECK_ERRORLOG
219
220# All done
221exit 0